Imports NeoTicker

<Microsoft.VisualBasic.ComClass()> <System.Runtime.InteropServices.ComVisible(True)> _
Public Class MainIDL
    Implements NeoTicker.IIDLIndicator

    Public Function IDLCallEx(ByVal NTIndicatorObjects As NeoTicker.NTIndicatorObjects) As Double Implements NeoTicker.IIDLIndicator.IDLCallEx
        Dim Param1, Param2, Param3 As IParamObj, _
            ItSelf As IItselfObj, _
            IndObj, IndObj1, BuySignal, SellSignal As INestedIndicatorObj, _
            TradeObj As ITradeObj, _
            NTLib As INTLibObj, _
            DSeries As IDataSeriesObj, _
            TotalSeries, FirstSeries, IndNum, i As Integer, _
            fmaName, smaName, xupName, xdownName, DSNum As String

        IDLCallEx = 0

        ' Initialize local variables pointing towards the NeoTicker indicator objects
        ' If you are converting VBScript into VB.NET, this section can reduce 
        ' changes required to the original script.

        With NTIndicatorObjects
            Param1 = .Param1
            Param2 = .Param2
            Param3 = .Param3
            ItSelf = .ItSelf
            TradeObj = .Trade
            NTLib = .NTLib
            DSeries = .DataSeries
        End With

        ' Actual script code starts here

        FirstSeries = 1
        'TotalSeries = DSeries.Count
        TotalSeries = Param3.Int

        For i = FirstSeries To TotalSeries
            DSNum = "#" + CStr(i)
            IndNum = CInt(CStr(i) + "1")
            fmaName = "myfma" + CStr(i)

            IndObj = ItSelf.UpdateIndicatorEx(IndNum)
            If IsNothing(IndObj) Then
                IndObj = ItSelf.MakeIndicatorEx( _
                                fmaName, IndNum, _
                                "average", _
                                New String() {DSNum}, _
                                New String() {Param1.Str})
            End If

            IndNum = CInt(CStr(i) + "2")
            smaName = "mysma" + CStr(i)

            IndObj1 = ItSelf.UpdateIndicatorEx(IndNum)
            If IsNothing(IndObj1) Then
                IndObj1 = ItSelf.MakeIndicatorEx( _
                                smaName, IndNum, _
                                "average", _
                                New String() {DSNum}, _
                                New String() {Param2.Str})
            End If

            IndNum = CInt(CStr(i) + "3")
            xupName = "xup" + CStr(i)

            BuySignal = ItSelf.UpdateIndicatorEx(IndNum)
            If IsNothing(BuySignal) Then
                BuySignal = ItSelf.MakeIndicatorEx( _
                               xupName, IndNum, _
                               "xabove", _
                                New String() {fmaName, smaName}, _
                                New String() {""})
            End If

            IndNum = CInt(CStr(i) + "4")
            xdownName = "xdown" + CStr(i)

            SellSignal = ItSelf.UpdateIndicatorEx(IndNum)
            If IsNothing(SellSignal) Then
                SellSignal = ItSelf.MakeIndicatorEx( _
                                xdownName, IndNum, _
                                "xbelow", _
                                New String() {fmaName, smaName}, _
                                New String() {""})
            End If

            If BuySignal.Value(0) > 0 Then
                TradeObj.BuyAtMarketEx(i, Param3.Int, "cross above long")
            End If

            If SellSignal.Value(0) > 0 Then
                TradeObj.SellAtMarketEx(i, Param3.Int, "cross below sell")
            End If
        Next


        ' return result

        ItSelf.Plot(1) = TradeObj.CurrentEquity

    End Function
End Class
